///////////////////////////////////////////////////////////////////
// Functy
// 3D graph drawing utility
//
// David Llewellyn-Jones
// http://www.flypig.co.uk
//
// Spring 2009
///////////////////////////////////////////////////////////////////

#ifndef CARTESIAN_H
#define CARTESIAN_H

///////////////////////////////////////////////////////////////////
// Includes

///////////////////////////////////////////////////////////////////
// Defines

///////////////////////////////////////////////////////////////////
// Structures and enumerations

typedef struct _CartesianPersist CartesianPersist;

///////////////////////////////////////////////////////////////////
// Global variables

///////////////////////////////////////////////////////////////////
// Function prototypes

CartesianPersist * NewCartesianPersist ();
void DeleteCartesianPersist (CartesianPersist * psCartesianData);

void CartesianSetFunction (char const * const szFunction, FuncPersist * psFuncData);
void CartesianSetFunctionColours (char const * const szRed, char const * const szGreen, char const * const szBlue, char const * const szAlpha, FuncPersist * psFuncData);
void CartesianPopulateVertices (FuncPersist * psFuncData);
void CartesianGetVertexDimensions (int * pnXVertices, int * pnYVertices, FuncPersist * psFuncData);
void CartesianGenerateVertices (FuncPersist * psFuncData);
void CartesianSetFunctionPosition (double fXMin, double fYMin, double fZMin, FuncPersist * psFuncData);
char * CartesianGenerateVertexShader (FuncPersist * psFuncData);
char * CartesianGenerateFragmentShader (FuncPersist * psFuncData);
void CartesianInitShader (FuncPersist * psFuncData);
void CartesianSetShaderActive (bool boActive, FuncPersist * psFuncData);
void CartesianUpdateCentre (FuncPersist * psFuncData);
void CartesianSetFunctionCentre (char const * const szXCentre, char const * const szYCentre, char const * const szZCentre, FuncPersist * psFuncData);
void CartesianGetCentre (double * afCentre, FuncPersist const * psFuncData);
char const * CartesianGetXCentreString (FuncPersist * psFuncData);
char const * CartesianGetYCentreString (FuncPersist * psFuncData);
char const * CartesianGetZCentreString (FuncPersist * psFuncData);
int CartesianOutputStoredVertices (FILE * hFile, bool boBinary, bool boScreenCoords, bool boExportAlpha, double fMultiplier, FuncPersist const * psFuncData);
int CartesianOutputStoredIndices (FILE * hFile, bool boBinary, double fMultiplier, int nOffset, FuncPersist const * psFuncData);
int CartesianCountStoredVertices (double fMultiplier, FuncPersist const * psFuncData);
int CartesianCountStoredFaces (double fMultiplier, FuncPersist const * psFuncData);

///////////////////////////////////////////////////////////////////
// Function definitions

#endif /* CARTESIAN_H */


