///////////////////////////////////////////////////////////////////
// Functy
// 3D graph drawing utility
//
// David Llewellyn-Jones
// http://www.flypig.co.uk
//
// Spring 2009
///////////////////////////////////////////////////////////////////

#ifndef FUNCTY_H
#define FUNCTY_H

///////////////////////////////////////////////////////////////////
// Includes

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <glade/glade.h>

#include "vis.h"
#include "function.h"

///////////////////////////////////////////////////////////////////
// Defines

///////////////////////////////////////////////////////////////////
// Structures and enumerations

typedef struct _FunctyPersist FunctyPersist;

struct _FunctyPersist {
  VisPersist * psVisData;
  GtkWidget * psDrawingArea;
  gboolean boTimeoutContinue;
  guint TimeoutID;
  GladeXML * psXML;
  FuncPersist * psFuncEdit;
  double fNewColour;
  bool boPausedModal;
  bool boFileLoaded;
  GString * szFilename;
  bool boFolderSet;
  bool boExportedModel;
  GString * szExportModelName;
  bool boBinary;
	double fExportMultiplier;
	bool boExportScreen;
	bool boExportAlpha;
  GString * szFolder;
  FUNCTYPE eNextFunctionType;
  bool boButtonBarHidden;
};

///////////////////////////////////////////////////////////////////
// Global variables

///////////////////////////////////////////////////////////////////
// Function prototypes

FunctyPersist * NewFunctyPersist (void);
void DeleteFunctyPersist (FunctyPersist * psFunctyData);

void SetFullScreenWindow (bool boFullScreen, FunctyPersist * psFunctyData);
void SetExportBinary (bool boBinary, FunctyPersist * psFunctyData);
void SetExportMultiplier (double fExportMultiplier, FunctyPersist * psFunctyData);
void SetExportScreen (bool boExportScreen, FunctyPersist * psFunctyData);
void SetExportAlpha (bool boExportAlpha, FunctyPersist * psFunctyData);

///////////////////////////////////////////////////////////////////
// Function definitions

#endif /* FUNCTY_H */

